output :-
        output_variables,
        output_constraints.

output_variables :-
        variable(Name, Domain),
        output_variable(Name, Domain),
        fail.
output_variables.

output_variable(Name, bool) :- !,
        term_to_atom(Name, N),
        output([bool,N]).
output_variable(Name, int(LB, UB)) :- !,
        term_to_atom(Name, N),
        output([int,N,LB,UB]).

output_constraints :-
        constraint(Constraint),
        translate_constraint(Constraint, C),
        output(C),
        fail.
output_constraints.

translate_constraint([], []) :- !.
translate_constraint(X, X) :- atomic(X), !.
translate_constraint(Name, N) :- variable(Name, _), !,
        term_to_atom(Name, N).
translate_constraint([F,collection(Collection)], [F|C]) :- !,
        findall(X, collection(Collection, X), C1),
        translate_constraint(C1, C).
translate_constraint([X1|Xs1], [X|Xs]) :- !,
        translate_constraint(X1, X),
        translate_constraint(Xs1, Xs).
translate_constraint(X, C) :-
        X =.. Xs,
        translate_constraint(Xs, C).

output(X) :-
        writeq(X), write('.'), nl.

:- output, halt.

